//
//  ddTableViewViewController.m
//  ddTableView
//
//  Created by Aakash Chaudhary on 22/07/11.
//  Copyright 2011 __MyCompanyName__. All rights reserved.
//

#import "ddTableViewViewController.h"

@implementation ddTableViewViewController

@synthesize tableViewA,tableViewB,listB,listA,dragView,label,currentPoint;

- (void)dealloc
{
    [super dealloc];
}

- (void)didReceiveMemoryWarning
{
    // Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
    
    // Release any cached data, images, etc that aren't in use.
}

#pragma mark - View lifecycle


// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad
{
    listA=[[NSMutableArray alloc]init];
    listB=[[NSMutableArray alloc]init];
    tableViewA.pagingEnabled = YES;
    tableViewB.pagingEnabled = YES;
//	tableViewA.scrollEnabled=YES;
//	[self.view addSubview:tableViewA];
    [listA addObject:@"ItemA1"];
    [listA addObject:@"ItemA2"];
    [listA addObject:@"ItemA3"];
    [listA addObject:@"ItemA4"];
    [listA addObject:@"ItemA5"];
    [listA addObject:@"ItemA6"];
    [listA addObject:@"ItemA7"];
    [listA addObject:@"ItemA8"];
    [listA addObject:@"ItemA9"];
    
//	tableViewA.scrollEnabled=YES;
//	[self.view addSubview:tableViewA];
    [listB addObject:@"ItemB1"];
    [listB addObject:@"ItemB2"];
    [listB addObject:@"ItemB3"];
    [listB addObject:@"ItemB4"];
    [listB addObject:@"ItemB5"];
    [listB addObject:@"ItemB6"];
    [listB addObject:@"ItemB7"];
    [listB addObject:@"ItemB8"];
    [listB addObject:@"ItemB9"];
    [self.view addSubview:dragView];
    dragView.center = CGPointMake(160, 560);
    
    [super viewDidLoad];
}

- (NSInteger)numberOfSectionsInTableView:(UITableView *)tableView
{
    return 1;
}

- (NSInteger)tableView:(UITableView *)tableView numberOfRowsInSection:(NSInteger)section{
    if(tableView == (UITableView *)tableViewA)
    return [listA count];
    else return [listB count];
}

- (UITableViewCell *)tableView:(UITableView *)tableView cellForRowAtIndexPath:(NSIndexPath *)indexPath{
    static NSString *CellIdentifier = @"Cell";
    UITableViewCell *cell = [tableView dequeueReusableCellWithIdentifier:CellIdentifier];
    if (cell == nil) 
        cell = [[[UITableViewCell alloc] initWithStyle:UITableViewCellStyleDefault reuseIdentifier:CellIdentifier] autorelease];

    if(tableView == tableViewA)
        cell.textLabel.text=[listA objectAtIndex:indexPath.row];
    else 
        cell.textLabel.text=[listB objectAtIndex:indexPath.row];
    return cell;
}

//First select row then press button to drag/drop
- (void)tableView:(UITableView *)tableView didSelectRowAtIndexPath:(NSIndexPath *)indexPath{
    NSInteger height;
    if(tableView == tableViewA){
        ///// put your cell customization code here...I've kept it simple :)
        label.text = [listA objectAtIndex:indexPath.row];
        listAtoB = TRUE;
        height = (indexPath.row - [[[tableViewA indexPathsForVisibleRows] objectAtIndex:0] row])*44;
    }
    else{
        ///// ...and here
        label.text = [listB objectAtIndex:indexPath.row];
        listAtoB = FALSE;
        height = (indexPath.row - [[[tableViewB indexPathsForVisibleRows] objectAtIndex:0] row])*44 + 240;
    }
    dragItemIndex = indexPath.row;
    dragView.center = CGPointMake(160, height+22);

    [tableView deselectRowAtIndexPath:indexPath animated:YES];

    currentPoint = dragView.center;
}

- (CGFloat)tableView:(UITableView *)tableView heightForRowAtIndexPath:(NSIndexPath *)indexPath{
    return 44;
}

-(void) animate{
    [UIView animateWithDuration:0.1 
                          delay:0.0 
                        options:UIViewAnimationOptionBeginFromCurrentState 
                     animations:^{
                         dragView.center = CGPointMake(160, currentPoint.y);
                     }
                     completion:^(BOOL finished){}];
}

-(void)touchesBegan:(NSSet *)touches withEvent:(UIEvent *)event{
    [tableViewA reloadData];
    [tableViewB reloadData];
    UITouch *touch =[touches anyObject];
    currentPoint =[touch locationInView:self.view];
    dragView.center = CGPointMake(160, currentPoint.y);
}

-(void)touchesMoved:(NSSet *)touches withEvent:(UIEvent *)event{
    UITouch *touch =[touches anyObject];
    currentPoint =[touch locationInView:self.view];
    [self animate];
    //NSLog(@"x: %f  y: %f",dragView.center.x,dragView.center.y);
}

-(void)touchesEnded:(NSSet *)touches withEvent:(UIEvent *)event{
    dragView.center = CGPointMake(160, 560);
    int addAtIndex;
    id tempObj;
    if(listAtoB){
        if(currentPoint.y>=240){
            addAtIndex = [[[tableViewB indexPathsForVisibleRows] objectAtIndex:0] row] + ((NSInteger)((currentPoint.y-240)/44));
            [listB insertObject:[listA objectAtIndex:dragItemIndex] atIndex:addAtIndex];
            [listA removeObjectAtIndex:dragItemIndex];}
        else if (currentPoint.y<=210){
            addAtIndex = [[[tableViewA indexPathsForVisibleRows] objectAtIndex:0] row] + ((NSInteger)(currentPoint.y / 44));
            tempObj = [listA objectAtIndex:dragItemIndex];
            [listA removeObjectAtIndex:dragItemIndex];
            [listA insertObject:tempObj atIndex:addAtIndex];
        }
    }
    else{
    if(currentPoint.y<=210){
        addAtIndex = [[[tableViewA indexPathsForVisibleRows] objectAtIndex:0] row] + ((NSInteger)(currentPoint.y / 44));
        [listA insertObject:[listB objectAtIndex:dragItemIndex] atIndex:addAtIndex];
        [listB removeObjectAtIndex:dragItemIndex];}
    else if(currentPoint.y>=240){
        addAtIndex = [[[tableViewB indexPathsForVisibleRows] objectAtIndex:0] row] + ((NSInteger)((currentPoint.y-240)/ 44));
        tempObj = [listB objectAtIndex:dragItemIndex];
        [listB removeObjectAtIndex:dragItemIndex];
        [listB insertObject:tempObj atIndex:addAtIndex];
    }}
    [tableViewA reloadData];
    [tableViewB reloadData];
}



- (void)viewDidUnload
{
    [super viewDidUnload];
    // Release any retained subviews of the main view.
    // e.g. self.myOutlet = nil;
}

- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation
{
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}

@end
